
.include"m8def.inc"

.def	temp	=r16	;Notizblock
.def	temp1	=r17	;Hilfsregister

.equ	timer0	=tcnt0		;Timer 0
.equ	scaler0	=tccr0		;Vorteiler Timer 0
.equ	scaler1	=tccr1b		;Vorteiler Timer 1

.equ	PINSD	= 0b10111111	; Pins fr die LCD-Ansteuerung ber Port D

;***************  Sprungadressen fr die Interrupts  ******************************************
	rjmp reset	; Reset
	reti		; External IRQ 0
	reti		; External IRQ 1
	reti		; Timer 2 Compare 
	reti		; Timer 2 Overflow
	reti		; Timer 1 Capture Event
	reti		; Timer 1 Compare A
	reti		; Timer 1 Compare B
	reti		; Timer 1 Overflow
	reti		; Timer 0 Overflow
	reti		; SPI Transfer Complete
	reti		; UART Rx Complete
	reti		; UART Data Register Empty
	reti		; UART Tx Compplete
	reti		; ADC Conversion Complete
	reti		; EEPROM Ready
	reti		; Analog Comparator
	reti		; TWI
	reti		; SPM ready	
	
reset: 	cli				;alle Interrupts sperren

	ldi	temp,high(RAMEND)	;Position Stackpointer festlegen
	out	SPH,temp
	ldi	temp,low(RAMEND)
	out	SPL,temp

;***************  Initialisierung der PORTS  **********************************
	ldi	temp,PINSD		;setzen der Portpins D als Ausgang (PINSD=0b10111111)
	out	ddrd,temp		;zur Steuerung des LC-Display

	rcall	lcd_init		;LC-Display initialisieren
	rcall	lcd_clear		;und Inhalte lschen

	sei				;Interrupts freigeben

;***************  schreibe etwas ins Display  **********************************************

;***************  in die obere zeile String _1   ****************************************

        ldi ZL, LOW(string_1*2)		;Startadresse des Strings in den
        ldi ZH, HIGH(string_1*2)	;Z-Pointer laden
	ldi	temp, 0b10000011	;Cursor auf 1. Zeile/4. Stelle
	rcall	lcd_command
print_oben:
        lpm				;Erstes Byte des Strings nach R0 lesen
        tst	R0			;R0 auf 0 testen
        breq	end_print_oben		;wenn 0, dann fertig
        mov	temp,r0			;Inhalt von R0 nach temp kopieren
	rcall	lcd_data		;und auf das Display ausgeben
        adiw	Zl,1			;Adresse des Z-Pointers um 1 erhhen
        rjmp	print_oben		;wieder zum Anfang springen
end_print_oben:

;***************  und in die untere Zeile String _2   ****************************************

        ldi ZH, HIGH(string_2*2)	;Startadresse des Strings in den
        ldi ZL, LOW(string_2*2)		;Z-Pointer laden
	ldi	temp, 0b11000111	;Cursor auf 2. Zeile/6. Stelle
	rcall	lcd_command
print_unten:
        lpm				;Erstes Byte des Strings nach R0 lesen
        tst	R0			;R0 auf 0 testen
        breq	end_print_unten		;wenn 0, dann fertig
        mov	temp,r0			;Inhalt von R0 nach temp kopieren
	rcall	lcd_data		;und auf das Display ausgeben
        adiw	Zl,1			;Adresse des Z-Pointers um 1 erhhen
        rjmp	print_unten		;wieder zum Anfang springen
end_print_unten:

main:
	rjmp	main			;warte bis der Strom ausgeht

.include"lcd.inc"

string_1:	.db "Hallo",0		;die Null beendet die gltige Zeichenkette

string_2:	.db "World",0